/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.59 Revision 1.117
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/mysql.eclass,v 1.59 2007/01/05 00:07:23 vivo Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/mysql.eclass,v 1.117 2009/11/19 18:22:44 robbat2 Exp $
4# kate: encoding utf-8; eol unix;
5# kate: indent-width 4; mixedindent off; remove-trailing-space on; space-indent off;
6# kate: word-wrap-column 80; word-wrap off;
7 4
8# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 5# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
6# Maintainer: MySQL Team <mysql-bugs@gentoo.org>
9# Maintainer: Luca Longinotti <chtekk@gentoo.org> 7# - Luca Longinotti <chtekk@gentoo.org>
8# - Robin H. Johnson <robbat2@gentoo.org>
10 9
11# Note that MYSQL_VERSION_ID must be empty !!!
12
13ECLASS="mysql"
14INHERITED="$INHERITED $ECLASS"
15WANT_AUTOCONF="latest" 10WANT_AUTOCONF="latest"
16WANT_AUTOMAKE="latest" 11WANT_AUTOMAKE="latest"
12
17inherit eutils flag-o-matic gnuconfig autotools mysql_fx 13inherit eutils flag-o-matic gnuconfig autotools mysql_fx versionator
14
15case "${EAPI:-0}" in
16 2)
17 EXPORT_FUNCTIONS pkg_setup \
18 src_unpack src_prepare \
19 src_configure src_compile \
20 src_install \
21 pkg_preinst pkg_postinst \
22 pkg_config pkg_postrm
23 IUSE_DEFAULT_ON='+'
24 ;;
25 *)
26 EXPORT_FUNCTIONS pkg_setup \
27 src_unpack \
28 src_compile \
29 src_install \
30 pkg_preinst pkg_postinst \
31 pkg_config pkg_postrm
32 ;;
33esac
18 34
19# Shorten the path because the socket path length must be shorter than 107 chars 35# Shorten the path because the socket path length must be shorter than 107 chars
20# and we will run a mysql server during test phase 36# and we will run a mysql server during test phase
21S="${WORKDIR}/mysql" 37S="${WORKDIR}/mysql"
22 38
23# avoid running userspace code 8 times per ebuild :(
24if [[ "${_MYPVR}" != "${PVR}" ]] && [[ -n "${PVR}" ]]
25then
26 _MYPVR=${PVR}
27
28 [[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070105" 39[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20090228-0714Z"
29 40if [[ "${MY_EXTRAS_VER}" == "live" ]]; then
30 if [[ ${PR#r} -lt 60 ]] ; then 41 EGIT_PROJECT=mysql-extras
31 IS_BITKEEPER=0 42 EGIT_REPO_URI="git://git.overlays.gentoo.org/proj/mysql-extras.git"
32 elif [[ ${PR#r} -lt 90 ]] ; then 43 inherit git
33 IS_BITKEEPER=60
34 else
35 IS_BITKEEPER=90
36 fi 44fi
37 45
38 # MYSQL_VERSION_ID will be: 46# MYSQL_VERSION_ID will be:
39 # major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 47# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
40 # This is an important part, because many of the choices the MySQL ebuild will do 48# This is an important part, because many of the choices the MySQL ebuild will do
41 # depend on this variable. 49# depend on this variable.
42 # In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803" 50# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
51# We also strip off upstream's trailing letter that they use to respin tarballs
52
43 MYSQL_VERSION_ID="" 53MYSQL_VERSION_ID=""
54tpv="${PV%[a-z]}"
44 tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}" 55tpv=( ${tpv//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}"
45 for vatom in 0 1 2 3 ; do 56for vatom in 0 1 2 3 ; do
46 # pad to length 2 57 # pad to length 2
47 tpv[${vatom}]="00${tpv[${vatom}]}" 58 tpv[${vatom}]="00${tpv[${vatom}]}"
48 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}" 59 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}"
49 done 60done
50 # strip leading "0" (otherwise it's considered an octal number by BASH) 61# strip leading "0" (otherwise it's considered an octal number by BASH)
51 MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"} 62MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
52 63
64# Community features are available in mysql-community
65# AND in the re-merged mysql-5.0.82 and newer
66if [ "${PN}" == "mysql-community" ]; then
67 MYSQL_COMMUNITY_FEATURES=1
68elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then
69 MYSQL_COMMUNITY_FEATURES=1
70elif [ "${PV#5.1}" != "${PV}" ] && mysql_version_is_at_least "5.1.28"; then
71 MYSQL_COMMUNITY_FEATURES=1
72else
73 MYSQL_COMMUNITY_FEATURES=0
74fi
75
53 # Be warned, *DEPEND are version-dependant 76# Be warned, *DEPEND are version-dependant
77# These are used for both runtime and compiletime
54 DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d ) 78DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d )
55 userland_GNU? ( sys-process/procps ) 79 userland_GNU? ( sys-process/procps )
56 >=sys-apps/sed-4 80 >=sys-apps/sed-4
57 >=sys-apps/texinfo-4.7-r1 81 >=sys-apps/texinfo-4.7-r1
58 >=sys-libs/readline-4.1 82 >=sys-libs/readline-4.1
59 >=sys-libs/zlib-1.2.3 83 >=sys-libs/zlib-1.2.3"
60 "
61 84
62 # having different flavours at the same time is not a good idea 85# Having different flavours at the same time is not a good idea
63 for i in "" "-community" "-slotted" ; do 86for i in "" "-community" ; do
64 [[ "${i}" == ${PN#mysql} ]] || 87 [[ "${i}" == ${PN#mysql} ]] ||
65 DEPEND="${DEPEND} !dev-db/mysql${i}" 88 DEPEND="${DEPEND} !dev-db/mysql${i}"
66 done 89done
67 90
91RDEPEND="${DEPEND}
92 !minimal? ( dev-db/mysql-init-scripts )
93 selinux? ( sec-policy/selinux-mysql )"
94
95# compile-time-only
68 mysql_version_is_at_least "5.1" \ 96mysql_version_is_at_least "5.1" \
69 || DEPEND="${DEPEND} berkdb? ( sys-apps/ed )" 97|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
70 98
99# compile-time-only
100mysql_version_is_at_least "5.1.12" \
101&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3"
102
71 # dev-perl/DBD-mysql is needed by some scripts installed by MySQL 103# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
72 PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 104PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
73 105
74 if mysql_version_is_at_least "5.1.12" ; then 106# For other stuff to bring us in
75 DEPEND="${DEPEND} innodb? ( >=dev-util/cmake-2.4.3 )" 107PDEPEND="${PDEPEND} =virtual/mysql-$(get_version_component_range 1-2 ${PV})"
108
109# Work out the default SERVER_URI correctly
110if [ -z "${SERVER_URI}" ]; then
111 # The community build is on the mirrors
112 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
113 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${PV//_/-}.tar.gz"
114 # The (old) enterprise source is on the primary site only
115 elif [ "${PN}" == "mysql" ]; then
116 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${PV//_/-}.tar.gz"
117 fi
76 fi 118fi
77 119
78 # BitKeeper dependency, compile-time only
79 [[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client"
80
81 if [[ ${PN} == "mysql-slotted" ]] ; then
82 DEPEND="${DEPEND} app-admin/eselect-mysql"
83 fi
84
85 if [[ ${PN} == "mysql-slotted" ]] ; then
86 SLOT=""
87 tpv=( ${PV//[-._]/ } )
88 for vatom in 0 1 2 ; do
89 SLOT="${SLOT}${tpv[${vatom}]}_"
90 done
91 #finally SLOT=5_0_24
92 SLOT=${SLOT:0:${#SLOT}-1}
93 else
94 SLOT="0"
95 fi
96
97 # Define correct SRC_URIs 120# Define correct SRC_URIs
98 SRC_URI=" 121SRC_URI="${SERVER_URI}"
99 ${SERVER_URI} 122
123[[ ${MY_EXTRAS_VER} != live ]] && SRC_URI="${SRC_URI}
124 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
100 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 125 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
101 "
102 mysql_version_is_at_least "5.1.12" \ 126mysql_version_is_at_least "5.1.12" \
103 && [[ -n "${PBXT_VERSION}" ]] \ 127&& [[ -n "${PBXT_VERSION}" ]] \
104 && SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )" 128&& SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )"
105 129
106 DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 130DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
107 HOMEPAGE="http://www.mysql.com/" 131HOMEPAGE="http://www.mysql.com/"
108 LICENSE="GPL-2" 132LICENSE="GPL-2"
133SLOT="0"
109 IUSE="big-tables debug embedded minimal perl selinux ssl static" 134IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static"
110 RESTRICT="confcache"
111 135
112 mysql_version_is_at_least "4.1" \ 136mysql_version_is_at_least "4.1" \
113 && IUSE="${IUSE} latin1" 137&& IUSE="${IUSE} latin1"
114 138
115 mysql_version_is_at_least "4.1.3" \ 139mysql_version_is_at_least "4.1.3" \
116 && IUSE="${IUSE} cluster extraengine" 140&& IUSE="${IUSE} cluster extraengine"
117 141
118 mysql_version_is_at_least "5.0" \ 142mysql_version_is_at_least "5.0" \
119 || IUSE="${IUSE} raid" 143|| IUSE="${IUSE} raid"
120 144
121 mysql_version_is_at_least "5.0.18" \ 145mysql_version_is_at_least "5.0.18" \
122 && IUSE="${IUSE} max-idx-128" 146&& IUSE="${IUSE} max-idx-128"
123 147
124 mysql_version_is_at_least "5.1" \ 148mysql_version_is_at_least "5.1" \
125 && IUSE="${IUSE} innodb"
126
127 mysql_version_is_at_least "5.1" \
128 || IUSE="${IUSE} berkdb" 149|| IUSE="${IUSE} berkdb"
129 150
130 mysql_version_is_at_least "5.1.12" \ 151mysql_version_is_at_least "5.1.12" \
131 && IUSE="${IUSE} pbxt" 152&& IUSE="${IUSE} pbxt"
132 153
133 RDEPEND="${DEPEND} 154[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \
134 sys-apps/mysql 155&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling"
135 selinux? ( sec-policy/selinux-mysql )
136 "
137
138fi # if [[ "${_MYPVR}" != "${PVR}" ]]
139
140EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \
141 pkg_postinst pkg_config pkg_postrm
142 156
143# 157#
144# HELPER FUNCTIONS: 158# HELPER FUNCTIONS:
145# 159#
146
147bitkeeper_fetch() {
148
149 local reposuf
150 if [[ -z "${1}" ]] ; then
151 local tpv
152 tpv=( ${PV//[-._]/ } )
153 reposuf="mysql-${tpv[0]}.${tpv[1]}"
154 else
155 reposuf="${1}"
156 fi
157 einfo "using \"${reposuf}\" repository."
158 local repo_uri="bk://mysql.bkbits.net/${reposuf}"
159 ## -- ebk_store_dir: bitkeeper sources store directory
160 local ebk_store_dir="${PORTAGE_ACTUAL_DISTDIR-${DISTDIR}}/bk-src"
161 ## -- ebk_fetch_cmd: bitkeeper fetch command
162 # always fetch the latest revision, use -r<revision> if a specified revision is wanted
163 # hint: does not work
164 local ebk_fetch_cmd="sfioball"
165 ## -- ebk_update_cmd: bitkeeper update command
166 local ebk_update_cmd="update"
167
168 #addread "/etc/bitkeeper"
169 addwrite "${ebk_store_dir}"
170
171 if [[ ! -d "${ebk_store_dir}" ]]; then
172 debug-print "${FUNCNAME}: initial checkout. creating bitkeeper directory"
173 mkdir -p "${ebk_store_dir}" || die "${EBK}: can't mkdir ${ebk_store_dir}."
174 fi
175
176 pushd "${ebk_store_dir}" || die "${EBK}: can't chdir to ${ebk_store_dir}"
177
178 local wc_path=${reposuf}
179
180 if [[ ! -d "${wc_path}" ]]; then
181 local options="-r+"
182 # first check out
183 einfo "bitkeeper check out start -->"
184 einfo " repository: ${repo_uri}"
185 ${ebk_fetch_cmd} ${options} "${repo_uri}" ${wc_path} \
186 || die "${EBK}: can't fetch from ${repo_uri}."
187 else
188 if [[ ! -d "${wc_path}/BK" ]]; then
189 popd
190 die "Look like ${wc_path} is not a bitkeeper path."
191 fi
192
193 # update working copy
194 einfo "bitkeeper update start -->"
195 einfo " repository: ${repo_uri}"
196
197 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \
198 || die "BK: can't update from ${repo_uri} to ${wc_path}."
199 fi
200
201 einfo " working copy: ${wc_path}"
202 cd "${wc_path}"
203 rsync -rlpgo --exclude="BK/" . "${S}" || die "BK: can't export to ${S}."
204
205 echo
206 popd
207
208}
209 160
210mysql_disable_test() { 161mysql_disable_test() {
211 local testname="${1}" ; shift 162 local testname="${1}" ; shift
212 local reason="${@}" 163 local reason="${@}"
213 local mysql_disable_file="${S}/mysql-test/t/disabled.def" 164 local mysql_disable_file="${S}/mysql-test/t/disabled.def"
214 echo ${testname} : ${reason} >> "${mysql_disable_file}" 165 echo ${testname} : ${reason} >> "${mysql_disable_file}"
215 ewarn "test \"${testname}\" disabled because: \"${reason}\"" 166 ewarn "test '${testname}' disabled: '${reason}'"
216} 167}
217 168
218# void mysql_init_vars() 169# void mysql_init_vars()
219# 170#
220# Initialize global variables 171# Initialize global variables
221# 2005-11-19 <vivo@gentoo.org> 172# 2005-11-19 <vivo@gentoo.org>
222 173
223mysql_init_vars() { 174mysql_init_vars() {
224 if [[ ${SLOT} == "0" ]] ; then
225 MY_SUFFIX=""
226 else
227 MY_SUFFIX=${MY_SUFFIX:-"-${SLOT}"}
228 fi
229 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR:-"/usr/share/mysql${MY_SUFFIX}"} 175 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR="/usr/share/mysql"}
230 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql${MY_SUFFIX}"} 176 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql"}
231 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql${MY_SUFFIX}"} 177 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"}
232 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql${MY_SUFFIX}"} 178 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"}
233 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql${MY_SUFFIX}"} 179 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql"}
234 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql${MY_SUFFIX}"} 180 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql"}
235 181
236 if [[ -z "${DATADIR}" ]] ; then 182 if [[ -z "${MY_DATADIR}" ]] ; then
237 DATADIR="" 183 MY_DATADIR=""
238 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then 184 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then
239 DATADIR=`"my_print_defaults${MY_SUFFIX}" mysqld 2>/dev/null \ 185 MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
240 | sed -ne '/datadir/s|^--datadir=||p' \ 186 | sed -ne '/datadir/s|^--datadir=||p' \
241 | tail -n1` 187 | tail -n1`
242 if [[ -z "${DATADIR}" ]] ; then 188 if [[ -z "${MY_DATADIR}" ]] ; then
243 DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \ 189 MY_DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \
244 | sed -e 's/.*=\s*//'` 190 | sed -e 's/.*=\s*//' \
191 | tail -n1`
245 fi 192 fi
246 fi 193 fi
247 if [[ -z "${DATADIR}" ]] ; then 194 if [[ -z "${MY_DATADIR}" ]] ; then
248 DATADIR="${MY_LOCALSTATEDIR}" 195 MY_DATADIR="${MY_LOCALSTATEDIR}"
249 einfo "Using default DATADIR" 196 einfo "Using default MY_DATADIR"
250 fi 197 fi
251 elog "MySQL DATADIR is ${DATADIR}" 198 elog "MySQL MY_DATADIR is ${MY_DATADIR}"
252 199
253 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then 200 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then
254 if [[ -e "${DATADIR}" ]] ; then 201 if [[ -e "${MY_DATADIR}" ]] ; then
255 elog "Previous datadir found, it's YOUR job to change" 202 # If you get this and you're wondering about it, see bug #207636
256 elog "ownership and take care of it" 203 elog "MySQL datadir found in ${MY_DATADIR}"
204 elog "A new one will not be created."
257 PREVIOUS_DATADIR="yes" 205 PREVIOUS_DATADIR="yes"
258 else 206 else
259 PREVIOUS_DATADIR="no" 207 PREVIOUS_DATADIR="no"
260 fi 208 fi
261 export PREVIOUS_DATADIR 209 export PREVIOUS_DATADIR
262 fi 210 fi
211 else
212 if [[ ${EBUILD_PHASE} == "config" ]]; then
213 local new_MY_DATADIR
214 new_MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
215 | sed -ne '/datadir/s|^--datadir=||p' \
216 | tail -n1`
217
218 if [[ ( -n "${new_MY_DATADIR}" ) && ( "${new_MY_DATADIR}" != "${MY_DATADIR}" ) ]]; then
219 ewarn "MySQL MY_DATADIR has changed"
220 ewarn "from ${MY_DATADIR}"
221 ewarn "to ${new_MY_DATADIR}"
222 MY_DATADIR="${new_MY_DATADIR}"
223 fi
224 fi
263 fi 225 fi
264 226
265 MY_SOURCEDIR=${SERVER_URI##*/} 227 MY_SOURCEDIR=${SERVER_URI##*/}
266 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*} 228 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
267 229
268 export MY_SUFFIX MY_SHAREDSTATEDIR MY_SYSCONFDIR 230 export MY_SHAREDSTATEDIR MY_SYSCONFDIR
269 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 231 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
270 export MY_INCLUDEDIR DATADIR MY_SOURCEDIR 232 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR
271} 233}
272 234
273configure_minimal() { 235configure_minimal() {
274 # These are things we exclude from a minimal build, please 236 # These are things we exclude from a minimal build, please
275 # note that the server actually does get built and installed, 237 # note that the server actually does get built and installed,
276 # but we then delete it before packaging. 238 # but we then delete it before packaging.
277 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication" 239 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication readline"
278 240
279 for i in ${minimal_exclude_list} ; do 241 for i in ${minimal_exclude_list} ; do
280 myconf="${myconf} --without-${i}" 242 myconf="${myconf} --without-${i}"
281 done 243 done
282 myconf="${myconf} --with-extra-charsets=none" 244 myconf="${myconf} --with-extra-charsets=none"
283 myconf="${myconf} --enable-local-infile" 245 myconf="${myconf} --enable-local-infile"
284 246
285 if useq "static" ; then 247 if use static ; then
286 myconf="${myconf} --with-client-ldflags=-all-static" 248 myconf="${myconf} --with-client-ldflags=-all-static"
287 myconf="${myconf} --disable-shared" 249 myconf="${myconf} --disable-shared --with-pic"
288 else 250 else
289 myconf="${myconf} --enable-shared --enable-static" 251 myconf="${myconf} --enable-shared --enable-static"
290 fi 252 fi
291 253
292 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then 254 if mysql_version_is_at_least "4.1" && ! use latin1 ; then
293 myconf="${myconf} --with-charset=utf8" 255 myconf="${myconf} --with-charset=utf8"
294 myconf="${myconf} --with-collation=utf8_general_ci" 256 myconf="${myconf} --with-collation=utf8_general_ci"
295 else 257 else
296 myconf="${myconf} --with-charset=latin1" 258 myconf="${myconf} --with-charset=latin1"
297 myconf="${myconf} --with-collation=latin1_swedish_ci" 259 myconf="${myconf} --with-collation=latin1_swedish_ci"
305 myconf="${myconf} --with-mysqld-user=mysql" 267 myconf="${myconf} --with-mysqld-user=mysql"
306 myconf="${myconf} --with-server" 268 myconf="${myconf} --with-server"
307 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock" 269 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock"
308 myconf="${myconf} --without-libwrap" 270 myconf="${myconf} --without-libwrap"
309 271
310 if useq "static" ; then 272 if use static ; then
311 myconf="${myconf} --with-mysqld-ldflags=-all-static" 273 myconf="${myconf} --with-mysqld-ldflags=-all-static"
312 myconf="${myconf} --with-client-ldflags=-all-static" 274 myconf="${myconf} --with-client-ldflags=-all-static"
313 myconf="${myconf} --disable-shared" 275 myconf="${myconf} --disable-shared --with-pic"
314 else 276 else
315 myconf="${myconf} --enable-shared --enable-static" 277 myconf="${myconf} --enable-shared --enable-static"
316 fi 278 fi
317 279
318 if useq "debug" ; then 280 if use debug ; then
319 myconf="${myconf} --with-debug=full" 281 myconf="${myconf} --with-debug=full"
320 else 282 else
321 myconf="${myconf} --without-debug" 283 myconf="${myconf} --without-debug"
322 mysql_version_is_at_least "4.1.3" \ 284 mysql_version_is_at_least "4.1.3" \
323 && useq "cluster" \ 285 && use cluster \
324 && myconf="${myconf} --without-ndb-debug" 286 && myconf="${myconf} --without-ndb-debug"
325 fi 287 fi
326 288
289 if [ -n "${MYSQL_DEFAULT_CHARSET}" -a -n "${MYSQL_DEFAULT_COLLATION}" ]; then
290 ewarn "You are using a custom charset of ${MYSQL_DEFAULT_CHARSET}"
291 ewarn "and a collation of ${MYSQL_DEFAULT_COLLATION}."
292 ewarn "You MUST file bugs without these variables set."
293 myconf="${myconf} --with-charset=${MYSQL_DEFAULT_CHARSET}"
294 myconf="${myconf} --with-collation=${MYSQL_DEFAULT_COLLATION}"
327 if mysql_version_is_at_least "4.1" && ! useq "latin1" ; then 295 elif mysql_version_is_at_least "4.1" && ! use latin1 ; then
328 myconf="${myconf} --with-charset=utf8" 296 myconf="${myconf} --with-charset=utf8"
329 myconf="${myconf} --with-collation=utf8_general_ci" 297 myconf="${myconf} --with-collation=utf8_general_ci"
330 else 298 else
331 myconf="${myconf} --with-charset=latin1" 299 myconf="${myconf} --with-charset=latin1"
332 myconf="${myconf} --with-collation=latin1_swedish_ci" 300 myconf="${myconf} --with-collation=latin1_swedish_ci"
333 fi 301 fi
334 302
335 if useq "embedded" ; then 303 if use embedded ; then
336 myconf="${myconf} --with-embedded-privilege-control" 304 myconf="${myconf} --with-embedded-privilege-control"
337 myconf="${myconf} --with-embedded-server" 305 myconf="${myconf} --with-embedded-server"
338 else 306 else
339 myconf="${myconf} --without-embedded-privilege-control" 307 myconf="${myconf} --without-embedded-privilege-control"
340 myconf="${myconf} --without-embedded-server" 308 myconf="${myconf} --without-embedded-server"
348 myconf="${myconf} --with-extra-tools" 316 myconf="${myconf} --with-extra-tools"
349 myconf="${myconf} --with-innodb" 317 myconf="${myconf} --with-innodb"
350 myconf="${myconf} --without-readline" 318 myconf="${myconf} --without-readline"
351 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)" 319 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
352 320
353 if useq "ssl" ; then
354 # --with-vio is not needed anymore, it's on by default and 321 # --with-vio is not needed anymore, it's on by default and
355 # has been removed from configure 322 # has been removed from configure
323 if use ssl ; then
356 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio" 324 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
325 fi
326
327 if mysql_version_is_at_least "5.1.11" ; then
328 myconf="${myconf} $(use_with ssl)"
329 else
330 myconf="${myconf} $(use_with ssl openssl)"
331 fi
332
357 if mysql_version_is_at_least "5.0.6" ; then 333 if mysql_version_is_at_least "5.0.60" ; then
358 # myconf="${myconf} --with-yassl" 334 if use berkdb ; then
335 elog "Berkeley DB support was disabled due to build failures"
336 elog "on multiple arches, go to a version earlier than 5.0.60"
337 elog "if you want it again. Gentoo bug #224067."
338 fi
359 myconf="${myconf} --with-ssl" 339 myconf="${myconf} --without-berkeley-db"
340 elif use berkdb ; then
341 # The following fix is due to a bug with bdb on SPARC's. See:
342 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
343 # It comes down to non-64-bit safety problems.
344 if use alpha || use amd64 || use hppa || use mips || use sparc ; then
345 elog "Berkeley DB support was disabled due to compatibility issues on this arch"
346 myconf="${myconf} --without-berkeley-db"
360 else 347 else
361 myconf="${myconf} --with-openssl" 348 myconf="${myconf} --with-berkeley-db=./bdb"
362 fi
363 else
364 myconf="${myconf} --without-openssl"
365 fi 349 fi
366 350 else
367 # The following fix is due to a bug with bdb on SPARC's. See:
368 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
369 # It comes down to non-64-bit safety problems.
370 if useq "sparc" || useq "alpha" || useq "hppa" || useq "mips" || useq "amd64" ; then
371 elog "Berkeley DB support was disabled due to incompatible arch"
372 myconf="${myconf} --without-berkeley-db" 351 myconf="${myconf} --without-berkeley-db"
373 else
374 if useq "berkdb" ; then
375 myconf="${myconf} --with-berkeley-db=./bdb"
376 else
377 myconf="${myconf} --without-berkeley-db"
378 fi
379 fi 352 fi
380 353
381 if mysql_version_is_at_least "4.1.3" ; then 354 if mysql_version_is_at_least "4.1.3" ; then
382 myconf="${myconf} --with-geometry" 355 myconf="${myconf} --with-geometry"
383 myconf="${myconf} $(use_with cluster ndbcluster)" 356 myconf="${myconf} $(use_with cluster ndbcluster)"
384 fi 357 fi
385 358
386 if mysql_version_is_at_least "4.1.3" && useq "extraengine" ; then 359 if mysql_version_is_at_least "4.1.3" && use extraengine ; then
387 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 360 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
388 myconf="${myconf} --with-archive-storage-engine" 361 myconf="${myconf} --with-archive-storage-engine"
389 362
390 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html 363 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
391 myconf="${myconf} --with-csv-storage-engine" 364 myconf="${myconf} --with-csv-storage-engine"
401 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html" 374 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html"
402 myconf="${myconf} --with-federated-storage-engine" 375 myconf="${myconf} --with-federated-storage-engine"
403 fi 376 fi
404 fi 377 fi
405 378
379 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
380 myconf="${myconf} `use_enable community community-features`"
381 if use community; then
382 myconf="${myconf} `use_enable profiling`"
383 else
384 myconf="${myconf} --disable-profiling"
385 fi
386 fi
387
406 mysql_version_is_at_least "5.0.18" \ 388 mysql_version_is_at_least "5.0.18" \
407 && useq "max-idx-128" \ 389 && use max-idx-128 \
408 && myconf="${myconf} --with-max-indexes=128" 390 && myconf="${myconf} --with-max-indexes=128"
409} 391}
410 392
411configure_51() { 393configure_51() {
412 # TODO: !!!! readd --without-readline 394 # TODO: !!!! readd --without-readline
417 myconf="${myconf} --with-geometry" 399 myconf="${myconf} --with-geometry"
418 myconf="${myconf} --with-readline" 400 myconf="${myconf} --with-readline"
419 myconf="${myconf} --with-row-based-replication" 401 myconf="${myconf} --with-row-based-replication"
420 myconf="${myconf} --with-zlib=/usr/$(get_libdir)" 402 myconf="${myconf} --with-zlib=/usr/$(get_libdir)"
421 myconf="${myconf} --without-pstack" 403 myconf="${myconf} --without-pstack"
422 useq "max-idx-128" && myconf="${myconf} --with-max-indexes=128" 404 use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
423 405
424 # 5.1 introduces a new way to manage storage engines (plugins) 406 # 5.1 introduces a new way to manage storage engines (plugins)
425 # like configuration=none 407 # like configuration=none
426 local plugins="csv,myisam,myisammrg,heap" 408 local plugins="csv,myisam,myisammrg,heap"
427 if useq "extraengine" ; then 409 if use extraengine ; then
428 # like configuration=max-no-ndb, archive and example removed in 5.1.11 410 # like configuration=max-no-ndb, archive and example removed in 5.1.11
429 plugins="${plugins},archive,blackhole,example,federated,partition" 411 plugins="${plugins},archive,blackhole,example,federated,partition"
430 412
431 elog "Before using the Federated storage engine, please be sure to read" 413 elog "Before using the Federated storage engine, please be sure to read"
432 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 414 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
433 fi 415 fi
434 416
435 if useq "innodb" ; then 417 # Upstream specifically requests that InnoDB always be built.
436 plugins="${plugins},innobase" 418 plugins="${plugins},innobase"
437 fi
438 419
439 # like configuration=max-no-ndb 420 # like configuration=max-no-ndb
440 if useq "cluster" ; then 421 if use cluster ; then
441 plugins="${plugins},ndbcluster" 422 plugins="${plugins},ndbcluster"
442 myconf="${myconf} --with-ndb-binlog" 423 myconf="${myconf} --with-ndb-binlog"
443 fi 424 fi
444 425
445 if mysql_version_is_at_least "5.2" ; then 426 if mysql_version_is_at_least "5.2" ; then
447 fi 428 fi
448 429
449 myconf="${myconf} --with-plugins=${plugins}" 430 myconf="${myconf} --with-plugins=${plugins}"
450} 431}
451 432
452pbxt_src_compile() { 433pbxt_src_configure() {
453 mysql_init_vars 434 mysql_init_vars
454 435
455 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 436 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
456 437
457 einfo "Reconfiguring dir '${PWD}'" 438 einfo "Reconfiguring dir '${PWD}'"
458 AT_GNUCONF_UPDATE="yes" eautoreconf 439 AT_GNUCONF_UPDATE="yes" eautoreconf
459 440
460 local myconf 441 local myconf=""
461 myconf="${myconf} --with-mysql=${S}"
462 mkdir -p ${T}/lib
463 myconf="${myconf} --libdir=${D}/${MY_LIBDIR}" 442 myconf="${myconf} --with-mysql=${S} --libdir=${D}/${MY_LIBDIR}"
464 useq "debug" && myconf="${myconf} --with-debug=full" 443 use debug && myconf="${myconf} --with-debug=full"
465 # TODO is safe/needed to use econf here ? 444 # TODO: is it safe/needed to use econf here ?
466 ./configure ${myconf} || die "problem configuring pbxt storage engine" 445 ./configure ${myconf} || die "Problem configuring PBXT storage engine"
446}
447
448pbxt_src_compile() {
449 # Be backwards compatible for now
450 if [[ $EAPI != 2 ]]; then
451 pbxt_src_configure
452 fi
467 # TODO is safe/needed to use emake here ? 453 # TODO: is it safe/needed to use emake here ?
468 make || die "problem making pbxt storage engine (${myconf})" 454 make || die "Problem making PBXT storage engine (${myconf})"
469 455
470 popd 456 popd
471 # TODO: modify test suite 457 # TODO: modify test suite for PBXT
472} 458}
473 459
474pbxt_src_install() { 460pbxt_src_install() {
475 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 461 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
476 make install || die "failed pbxt install" 462 make install || die "Failed to install PBXT"
477 popd 463 popd
478} 464}
479 465
480# 466#
481# EBUILD FUNCTIONS 467# EBUILD FUNCTIONS
482# 468#
483
484mysql_pkg_setup() { 469mysql_pkg_setup() {
485 enewgroup mysql 60 || die "problem adding 'mysql' group" 470 if hasq test ${FEATURES} ; then
486 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 471 if ! use minimal ; then
472 if [[ $UID -eq 0 ]]; then
473 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root."
474 fi
475 fi
476 fi
487 477
488 # Check for USE flag problems in pkg_setup 478 # Check for USE flag problems in pkg_setup
489 if useq "static" && useq "ssl" ; then 479 if use static && use ssl ; then
490 eerror "MySQL does not support being built statically with SSL support enabled!" 480 eerror "MySQL does not support being built statically with SSL support enabled!"
491 die "MySQL does not support being built statically with SSL support enabled!" 481 die "MySQL does not support being built statically with SSL support enabled!"
492 fi 482 fi
493 483
494 if ! mysql_version_is_at_least "5.0" \ 484 if ! mysql_version_is_at_least "5.0" \
495 && useq "raid" \ 485 && use raid \
496 && useq "static" ; then 486 && use static ; then
497 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically" 487 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically"
498 eerror "with RAID support enabled." 488 eerror "with RAID support enabled."
499 die "USE flags 'raid' and 'static' conflict!" 489 die "USE flags 'raid' and 'static' conflict!"
500 fi 490 fi
501 491
502 if mysql_version_is_at_least "4.1.3" \ 492 if mysql_version_is_at_least "4.1.3" \
503 && ( useq "cluster" || useq "extraengine" ) \ 493 && ( use cluster || use extraengine ) \
504 && useq "minimal" ; then 494 && use minimal ; then
505 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 495 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
506 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 496 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
507 fi 497 fi
508 498
499 # This should come after all of the die statements
500 enewgroup mysql 60 || die "problem adding 'mysql' group"
501 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
502
509 mysql_check_version_range "4.0 to 5.0.99.99" \ 503 mysql_check_version_range "4.0 to 5.0.99.99" \
510 && useq "berkdb" \ 504 && use berkdb \
511 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 505 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
512} 506}
513 507
514mysql_src_unpack() { 508mysql_src_unpack() {
515 # Initialize the proper variables first 509 # Initialize the proper variables first
516 mysql_init_vars 510 mysql_init_vars
517 511
518 unpack ${A} 512 unpack ${A}
519 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then 513 # Grab the patches
520 if mysql_check_version_range "5.1 to 5.1.99" ; then 514 [[ "${MY_EXTRAS_VER}" == "live" ]] && S="${WORKDIR}/mysql-extras" git_src_unpack
521 bitkeeper_fetch "mysql-5.1-ndb" 515
522 elif mysql_check_version_range "5.2.0 to 5.2.99" ; then
523 bitkeeper_fetch "mysql-5.2-falcon"
524 else
525 bitkeeper_fetch
526 fi
527 cd "${S}"
528 einfo "running upstream autorun on bk sources"
529 BUILD/autorun.sh
530 else
531 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}" 516 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}"
517
518 # Be backwards compatible for now
519 if [[ $EAPI != 2 ]]; then
520 mysql_src_prepare
521 fi
522}
523
524mysql_src_prepare() {
532 cd "${S}" 525 cd "${S}"
533 fi
534 526
535 # Apply the patches for this MySQL version 527 # Apply the patches for this MySQL version
536 EPATCH_SUFFIX="patch" 528 EPATCH_SUFFIX="patch"
537 mkdir -p "${EPATCH_SOURCE}" || die "unable to create epatch directory" 529 mkdir -p "${EPATCH_SOURCE}" || die "Unable to create epatch directory"
530 # Clean out old items
531 rm -f "${EPATCH_SOURCE}"/*
532 # Now link in right patches
538 mysql_mv_patches 533 mysql_mv_patches
539 epatch || die "failed to apply all patches" 534 # And apply
535 epatch
540 536
541 # Additional checks, remove bundled zlib 537 # Additional checks, remove bundled zlib
542 rm -f "${S}/zlib/"*.[ch] 538 rm -f "${S}/zlib/"*.[ch]
543 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 539 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
544 rm -f "scripts/mysqlbug" 540 rm -f "scripts/mysqlbug"
559 555
560 local rebuilddirlist d 556 local rebuilddirlist d
561 557
562 if mysql_version_is_at_least "5.1.12" ; then 558 if mysql_version_is_at_least "5.1.12" ; then
563 rebuilddirlist="." 559 rebuilddirlist="."
564 # TODO IMPO! Check this with a cmake expert 560 # TODO: check this with a cmake expert
565 useq "innodb" \
566 && cmake \ 561 cmake \
567 -DCMAKE_C_COMPILER=$(which $(tc-getCC)) \ 562 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \
568 -DCMAKE_CXX_COMPILER=$(which $(tc-getCC)) \ 563 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \
569 "storage/innobase" 564 "storage/innobase"
570 else 565 else
571 rebuilddirlist=". innobase" 566 rebuilddirlist=". innobase"
572 fi 567 fi
573 568
577 AT_GNUCONF_UPDATE="yes" eautoreconf 572 AT_GNUCONF_UPDATE="yes" eautoreconf
578 popd &>/dev/null 573 popd &>/dev/null
579 done 574 done
580 575
581 if mysql_check_version_range "4.1 to 5.0.99.99" \ 576 if mysql_check_version_range "4.1 to 5.0.99.99" \
582 && useq "berkdb" ; then 577 && use berkdb ; then
583 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh" 578 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh"
579 cp -f "/usr/share/aclocal/libtool.m4" "bdb/dist/aclocal/libtool.ac" \
580 || die "Could not copy libtool.m4 to bdb/dist/"
581 #These files exist only with libtool-2*, and need to be included.
582 if [ -f '/usr/share/aclocal/ltsugar.m4' ]; then
583 cat "/usr/share/aclocal/ltsugar.m4" >> "bdb/dist/aclocal/libtool.ac"
584 cat "/usr/share/aclocal/ltversion.m4" >> "bdb/dist/aclocal/libtool.ac"
585 cat "/usr/share/aclocal/lt~obsolete.m4" >> "bdb/dist/aclocal/libtool.ac"
586 cat "/usr/share/aclocal/ltoptions.m4" >> "bdb/dist/aclocal/libtool.ac"
587 fi
584 pushd "bdb/dist" \ 588 pushd "bdb/dist" &>/dev/null
585 && sh s_all \ 589 sh s_all \
586 || die "Failed bdb reconfigure" \ 590 || die "Failed bdb reconfigure"
587 &>/dev/null
588 popd &>/dev/null 591 popd &>/dev/null
589 fi 592 fi
590} 593}
591 594
592mysql_src_compile() { 595mysql_src_configure() {
593 # Make sure the vars are correctly initialized 596 # Make sure the vars are correctly initialized
594 mysql_init_vars 597 mysql_init_vars
595 598
596 # $myconf is modified by the configure_* functions 599 # $myconf is modified by the configure_* functions
597 local myconf="" 600 local myconf=""
598 601
599 if useq "minimal" ; then 602 if use minimal ; then
600 configure_minimal 603 configure_minimal
601 else 604 else
602 configure_common 605 configure_common
603 if mysql_version_is_at_least "5.1.10" ; then 606 if mysql_version_is_at_least "5.1.10" ; then
604 configure_51 607 configure_51
611 filter-flags "-O" "-O[01]" 614 filter-flags "-O" "-O[01]"
612 615
613 # glib-2.3.2_pre fix, bug #16496 616 # glib-2.3.2_pre fix, bug #16496
614 append-flags "-DHAVE_ERRNO_AS_DEFINE=1" 617 append-flags "-DHAVE_ERRNO_AS_DEFINE=1"
615 618
619 # As discovered by bug #246652, doing a double-level of SSP causes NDB to
620 # fail badly during cluster startup.
621 if [[ $(gcc-major-version) -lt 4 ]]; then
622 filter-flags "-fstack-protector-all"
623 fi
624
616 CXXFLAGS="${CXXFLAGS} -fno-exceptions -fno-strict-aliasing" 625 CXXFLAGS="${CXXFLAGS} -fno-exceptions -fno-strict-aliasing"
617 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti" 626 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti"
618 mysql_version_is_at_least "5.0" \ 627 mysql_version_is_at_least "5.0" \
619 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 628 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
620 export CXXFLAGS 629 export CXXFLAGS
621 630
631 # bug #283926, with GCC4.4, this is required to get correct behavior.
632 append-flags -fno-strict-aliasing
633
622 econf \ 634 econf \
623 --program-suffix="${MY_SUFFIX}" \
624 --libexecdir="/usr/sbin" \ 635 --libexecdir="/usr/sbin" \
625 --sysconfdir="${MY_SYSCONFDIR}" \ 636 --sysconfdir="${MY_SYSCONFDIR}" \
626 --localstatedir="${MY_LOCALSTATEDIR}" \ 637 --localstatedir="${MY_LOCALSTATEDIR}" \
627 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 638 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
628 --libdir="${MY_LIBDIR}" \ 639 --libdir="${MY_LIBDIR}" \
637 # TODO: Move this before autoreconf !!! 648 # TODO: Move this before autoreconf !!!
638 find . -type f -name Makefile -print0 \ 649 find . -type f -name Makefile -print0 \
639 | xargs -0 -n100 sed -i \ 650 | xargs -0 -n100 sed -i \
640 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 651 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
641 652
653 if [[ $EAPI == 2 ]]; then
654 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_configure
655 fi
656}
657
658mysql_src_compile() {
659 # Be backwards compatible for now
660 if [[ $EAPI != 2 ]]; then
661 mysql_src_configure
662 fi
663
642 emake || die "emake failed" 664 emake || die "emake failed"
643 665
644 mysql_version_is_at_least "5.1.1" && useq "pbxt" && pbxt_src_compile 666 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_compile
645} 667}
646 668
647mysql_src_install() { 669mysql_src_install() {
648 # Make sure the vars are correctly initialized 670 # Make sure the vars are correctly initialized
649 mysql_init_vars 671 mysql_init_vars
650 672
651 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die 673 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed"
652 674
653 mysql_version_is_at_least "5.1.12" && useq "pbxt" && pbxt_src_install 675 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_install
654
655 insinto "${MY_INCLUDEDIR}"
656 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h
657 676
658 # Convenience links 677 # Convenience links
678 einfo "Making Convenience links for mysqlcheck multi-call binary"
659 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlanalyze${MY_SUFFIX}" 679 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
660 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlrepair${MY_SUFFIX}" 680 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
661 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqloptimize${MY_SUFFIX}" 681 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize"
662 682
663 # Various junk (my-*.cnf moved elsewhere) 683 # Various junk (my-*.cnf moved elsewhere)
684 einfo "Removing duplicate /usr/share/mysql files"
664 rm -Rf "${D}/usr/share/info" 685 rm -Rf "${D}/usr/share/info"
665 for removeme in "mysql-log-rotate" mysql.server* \ 686 for removeme in "mysql-log-rotate" mysql.server* \
666 binary-configure* my-*.cnf mi_test_all* 687 binary-configure* my-*.cnf mi_test_all*
667 do 688 do
668 rm -f "${D}"/usr/share/mysql/${removeme} 689 rm -f "${D}"/usr/share/mysql/${removeme}
669 done 690 done
670 691
671 # TODO change at Makefile-am level
672 if [[ ${PN} == "mysql-slotted" ]] ; then
673 for moveme in "mysql_fix_privilege_tables.sql" \
674 "fill_help_tables.sql" "ndb-config-2-node.ini"
675 do
676 mv -f "${D}/usr/share/mysql/${moveme}" "${D}/usr/share/mysql${MY_SUFFIX}/" 2>/dev/null
677 done
678 fi
679
680 # clean up stuff for a minimal build 692 # Clean up stuff for a minimal build
681 if useq "minimal" ; then 693 if use minimal ; then
694 einfo "Remove all extra content for minimal build"
682 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench} 695 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
683 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 696 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
684 rm -f "${D}/usr/sbin/mysqld" 697 rm -f "${D}/usr/sbin/mysqld"
685 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 698 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
686 fi 699 fi
687 700
688 if [[ ${PN} == "mysql-slotted" ]] ; then
689 local notcatched=$(ls "${D}/usr/share/mysql"/*)
690 if [[ -n "${notcatched}" ]] ; then
691 ewarn "QA notice"
692 ewarn "${notcatched} files in /usr/share/mysql"
693 ewarn "bug mysql-herd to manage them"
694 fi
695 rm -Rf "${D}/usr/share/mysql"
696 fi
697
698 # Configuration stuff 701 # Configuration stuff
699 if mysql_version_is_at_least "4.1" ; then 702 if mysql_version_is_at_least "4.1" ; then
700 mysql_mycnf_version="4.1" 703 mysql_mycnf_version="4.1"
701 else 704 else
702 mysql_mycnf_version="4.0" 705 mysql_mycnf_version="4.0"
703 fi 706 fi
707 einfo "Building default my.cnf"
704 insinto "${MY_SYSCONFDIR}" 708 insinto "${MY_SYSCONFDIR}"
705 doins scripts/mysqlaccess.conf 709 doins scripts/mysqlaccess.conf
706 sed -e "s!@MY_SUFFIX@!${MY_SUFFIX}!g" \
707 -e "s!@DATADIR@!${DATADIR}!g" \ 710 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
708 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 711 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \
709 > "${TMPDIR}/my.cnf.ok" 712 > "${TMPDIR}/my.cnf.ok"
710 if mysql_version_is_at_least "4.1" && useq "latin1" ; then 713 if mysql_version_is_at_least "4.1" && use latin1 ; then
711 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 714 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok"
712 fi 715 fi
713 newins "${TMPDIR}/my.cnf.ok" my.cnf 716 newins "${TMPDIR}/my.cnf.ok" my.cnf
714 717
715 # Minimal builds don't have the MySQL server 718 # Minimal builds don't have the MySQL server
716 if ! useq "minimal" ; then 719 if ! use minimal ; then
720 einfo "Creating initial directories"
717 # Empty directories ... 721 # Empty directories ...
718 diropts "-m0750" 722 diropts "-m0750"
719 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then 723 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then
720 dodir "${DATADIR}" 724 dodir "${MY_DATADIR}"
721 keepdir "${DATADIR}" 725 keepdir "${MY_DATADIR}"
722 chown -R mysql:mysql "${D}/${DATADIR}" 726 chown -R mysql:mysql "${D}/${MY_DATADIR}"
723 fi 727 fi
724 728
725 diropts "-m0755" 729 diropts "-m0755"
726 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do 730 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do
727 dodir "${folder}" 731 dodir "${folder}"
729 chown -R mysql:mysql "${D}/${folder}" 733 chown -R mysql:mysql "${D}/${folder}"
730 done 734 done
731 fi 735 fi
732 736
733 # Docs 737 # Docs
738 einfo "Installing docs"
734 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 739 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE
740 doinfo "${S}"/Docs/mysql.info
735 741
736 # Minimal builds don't have the MySQL server 742 # Minimal builds don't have the MySQL server
737 if ! useq "minimal" ; then 743 if ! use minimal ; then
744 einfo "Including support files and sample configurations"
745 docinto "support-files"
746 for script in \
747 "${S}"/support-files/my-*.cnf \
748 "${S}"/support-files/magic \
749 "${S}"/support-files/ndb-config-2-node.ini
750 do
751 dodoc "${script}"
752 done
753
754 docinto "scripts"
755 for script in "${S}"/scripts/mysql* ; do
756 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
757 done
758
759 fi
760
761 mysql_lib_symlinks "${D}"
762}
763
764mysql_pkg_preinst() {
765 enewgroup mysql 60 || die "problem adding 'mysql' group"
766 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
767}
768
769mysql_pkg_postinst() {
770 # Make sure the vars are correctly initialized
771 mysql_init_vars
772
773 # Check FEATURES="collision-protect" before removing this
774 [[ -d "${ROOT}/var/log/mysql" ]] || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
775
776 # Secure the logfiles
777 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
778 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
779 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
780
781 # Minimal builds don't have the MySQL server
782 if ! use minimal ; then
738 docinto "support-files" 783 docinto "support-files"
739 for script in \ 784 for script in \
740 support-files/my-*.cnf \ 785 support-files/my-*.cnf \
741 support-files/magic \ 786 support-files/magic \
742 support-files/ndb-config-2-node.ini 787 support-files/ndb-config-2-node.ini
746 791
747 docinto "scripts" 792 docinto "scripts"
748 for script in scripts/mysql* ; do 793 for script in scripts/mysql* ; do
749 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 794 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
750 done 795 done
751 fi
752 796
753 if [[ ${PN} == "mysql-slotted" ]] ; then 797 einfo
754 # MOVED HERE DUE TO BUG #121445 798 elog "You might want to run:"
755 # create a list of files, to be used 799 elog "\"emerge --config =${CATEGORY}/${PF}\""
756 # by external utilities 800 elog "if this is a new install."
757 mkdir -p "${D}/var/lib/eselect/mysql/" 801 einfo
758 local filelist="${D}/var/lib/eselect/mysql/mysql${MY_SUFFIX}.filelist"
759 pushd "${D}/" &>/dev/null
760 find usr/bin/ usr/sbin/ \
761 -type f -name "*${MY_SUFFIX}*" \
762 -and -not -name "mysql_config${MY_SUFFIX}" \
763 > "${filelist}"
764 find usr/share/man \
765 -type f -name "*${MY_SUFFIX}*" \
766 | sed -e 's/$/.gz/' \
767 >> "${filelist}"
768 echo "${MY_SYSCONFDIR#"/"}" >> "${filelist}"
769 echo "${MY_LIBDIR#"/"}" >> "${filelist}"
770 echo "${MY_SHAREDSTATEDIR#"/"}" >> "${filelist}"
771 popd &>/dev/null
772 fi 802 fi
773 803
774 mysql_lib_symlinks "${D}" 804 if mysql_version_is_at_least "5.1.12" && use pbxt ; then
775} 805 # TODO: explain it better
806 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
807 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
808 elog "if, after that, you cannot start the MySQL server,"
809 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
810 elog "use the MySQL upgrade script to restore the table"
811 elog "or execute the following SQL command:"
812 elog " CREATE TABLE IF NOT EXISTS plugin ("
813 elog " name char(64) binary DEFAULT '' NOT NULL,"
814 elog " dl char(128) DEFAULT '' NOT NULL,"
815 elog " PRIMARY KEY (name)"
816 elog " ) CHARACTER SET utf8 COLLATE utf8_bin;"
817 fi
776 818
777mysql_pkg_preinst() { 819 mysql_check_version_range "4.0 to 5.0.99.99" \
778 enewgroup mysql 60 || die "problem adding 'mysql' group" 820 && use berkdb \
779 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 821 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
780} 822}
781 823
782mysql_pkg_postinst() { 824mysql_pkg_config() {
825 local old_MY_DATADIR="${MY_DATADIR}"
826
783 # Make sure the vars are correctly initialized 827 # Make sure the vars are correctly initialized
784 mysql_init_vars 828 mysql_init_vars
785 829
786 # Check FEATURES="collision-protect" before removing this
787 [[ -d "${ROOT}/var/log/mysql" ]] \
788 || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
789
790 # Secure the logfiles
791 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
792 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
793 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
794
795 # Minimal builds don't have the MySQL server
796 if ! useq "minimal" ; then
797 docinto "support-files"
798 for script in \
799 support-files/my-*.cnf \
800 support-files/magic \
801 support-files/ndb-config-2-node.ini
802 do
803 dodoc "${script}"
804 done
805
806 docinto "scripts"
807 for script in scripts/mysql* ; do
808 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
809 done
810 fi
811
812 einfo "you may want to read slotting upgrade documents in the overlay"
813 if useq "pbxt" && mysql_version_is_at_least "5.1" ; then
814 # TODO tell it better ;-)
815 einfo "mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
816 einfo "CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
817 einfo "if, after that you cannot start the mysql server"
818 einfo "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
819 einfo "use the mysql upgrade script to restore the table"
820 einfo " or "
821 einfo "CREATE TABLE IF NOT EXISTS plugin ("
822 einfo " name char(64) binary DEFAULT '' NOT NULL,"
823 einfo " dl char(128) DEFAULT '' NOT NULL,"
824 einfo " PRIMARY KEY (name)"
825 einfo ") CHARACTER SET utf8 COLLATE utf8_bin;"
826 fi
827 mysql_check_version_range "4.0 to 5.0.99.99" \
828 && useq "berkdb" \
829 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
830}
831
832mysql_pkg_config() {
833 # Make sure the vars are correctly initialized
834 mysql_init_vars
835
836 [[ -z "${DATADIR}" ]] && die "Sorry, unable to find DATADIR" 830 [[ -z "${MY_DATADIR}" ]] && die "Sorry, unable to find MY_DATADIR"
837 831
838 if built_with_use ${CATEGORY}/${PN} minimal ; then 832 if built_with_use ${CATEGORY}/${PN} minimal ; then
839 die "Minimal builds do NOT include the MySQL server" 833 die "Minimal builds do NOT include the MySQL server"
834 fi
835
836 if [[ ( -n "${MY_DATADIR}" ) && ( "${MY_DATADIR}" != "${old_MY_DATADIR}" ) ]]; then
837 local MY_DATADIR_s="$(strip_duplicate_slashes ${ROOT}/${MY_DATADIR})"
838 local old_MY_DATADIR_s="$(strip_duplicate_slashes ${ROOT}/${old_MY_DATADIR})"
839
840 if [[ -d "${old_MY_DATADIR_s}" ]]; then
841 if [[ -d "${MY_DATADIR_s}" ]]; then
842 ewarn "Both ${old_MY_DATADIR_s} and ${MY_DATADIR_s} exist"
843 ewarn "Attempting to use ${MY_DATADIR_s} and preserving ${old_MY_DATADIR_s}"
844 else
845 elog "Moving MY_DATADIR from ${old_MY_DATADIR_s} to ${MY_DATADIR_s}"
846 mv --strip-trailing-slashes -T "${old_MY_DATADIR_s}" "${MY_DATADIR_s}" \
847 || die "Moving MY_DATADIR failed"
848 fi
849 else
850 ewarn "Previous MY_DATADIR (${old_MY_DATADIR_s}) does not exist"
851 if [[ -d "${MY_DATADIR_s}" ]]; then
852 ewarn "Attempting to use ${MY_DATADIR_s}"
853 else
854 eerror "New MY_DATADIR (${MY_DATADIR_s}) does not exist"
855 die "Configuration Failed! Please reinstall ${CATEGORY}/${PN}"
856 fi
857 fi
840 fi 858 fi
841 859
842 local pwd1="a" 860 local pwd1="a"
843 local pwd2="b" 861 local pwd2="b"
844 local maxtry=5 862 local maxtry=5
845 863
846 if [[ -d "${ROOT}/${DATADIR}/mysql" ]] ; then 864 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then
847 ewarn "You have already a MySQL database in place." 865 ewarn "You have already a MySQL database in place."
848 ewarn "(${ROOT}/${DATADIR}/*)" 866 ewarn "(${ROOT}/${MY_DATADIR}/*)"
849 ewarn "Please rename or delete it if you wish to replace it." 867 ewarn "Please rename or delete it if you wish to replace it."
850 die "MySQL database already exists!" 868 die "MySQL database already exists!"
851 fi 869 fi
870
871 # Bug #213475 - MySQL _will_ object strenously if your machine is named
872 # localhost. Also causes weird failures.
873 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost"
852 874
853 einfo "Creating the mysql database and setting proper" 875 einfo "Creating the mysql database and setting proper"
854 einfo "permissions on it ..." 876 einfo "permissions on it ..."
855 877
856 einfo "Insert a password for the mysql 'root' user" 878 einfo "Insert a password for the mysql 'root' user"
872 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \ 894 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \
873 || touch "${TMPDIR}/fill_help_tables.sql" 895 || touch "${TMPDIR}/fill_help_tables.sql"
874 help_tables="${TMPDIR}/fill_help_tables.sql" 896 help_tables="${TMPDIR}/fill_help_tables.sql"
875 897
876 pushd "${TMPDIR}" &>/dev/null 898 pushd "${TMPDIR}" &>/dev/null
877 "${ROOT}/usr/bin/mysql_install_db" | grep -B5 -A999 -i "ERROR" 899 "${ROOT}/usr/bin/mysql_install_db" >"${TMPDIR}"/mysql_install_db.log 2>&1
900 if [ $? -ne 0 ]; then
901 grep -B5 -A999 -i "ERROR" "${TMPDIR}"/mysql_install_db.log 1>&2
902 die "Failed to run mysql_install_db. Please review /var/log/mysql/mysqld.err AND ${TMPDIR}/mysql_install_db.log"
903 fi
878 popd &>/dev/null 904 popd &>/dev/null
879 [[ -f "${ROOT}/${DATADIR}/mysql/user.frm" ]] \ 905 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
880 || die "MySQL databases not installed" 906 || die "MySQL databases not installed"
881 chown -R mysql:mysql "${ROOT}/${DATADIR}" 2> /dev/null 907 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null
882 chmod 0750 "${ROOT}/${DATADIR}" 2> /dev/null 908 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null
883 909
884 if mysql_version_is_at_least "4.1.3" ; then 910 if mysql_version_is_at_least "4.1.3" ; then
885 options="--skip-ndbcluster" 911 options="--skip-ndbcluster"
886 912
887 # Filling timezones, see 913 # Filling timezones, see
898 local mysqld="${ROOT}/usr/sbin/mysqld \ 924 local mysqld="${ROOT}/usr/sbin/mysqld \
899 ${options} \ 925 ${options} \
900 --user=mysql \ 926 --user=mysql \
901 --skip-grant-tables \ 927 --skip-grant-tables \
902 --basedir=${ROOT}/usr \ 928 --basedir=${ROOT}/usr \
903 --datadir=${ROOT}/${DATADIR} \ 929 --datadir=${ROOT}/${MY_DATADIR} \
904 --skip-innodb \ 930 --skip-innodb \
905 --skip-bdb \ 931 --skip-bdb \
906 --skip-networking \ 932 --skip-networking \
907 --max_allowed_packet=8M \ 933 --max_allowed_packet=8M \
908 --net_buffer_length=16K \ 934 --net_buffer_length=16K \
938 wait %1 964 wait %1
939 einfo "Done" 965 einfo "Done"
940} 966}
941 967
942mysql_pkg_postrm() { 968mysql_pkg_postrm() {
943 if [[ ${PN} == "mysql-slotted" ]] ; then
944 mysql_lib_symlinks 969 : # mysql_lib_symlinks "${D}"
945 mysql_clients_link_to_best_version
946 fi
947} 970}

Legend:
Removed from v.1.59  
changed lines
  Added in v.1.117

  ViewVC Help
Powered by ViewVC 1.1.20